import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;

public class ShapeDraw01 extends JFrame {
	private class JPanel01 extends JPanel {
		private int bx, by;
		private int cx, cy;

		private JPanel01(){
			setPreferredSize(new Dimension(200, 200));
			setBackground(Color.white);
			MouseInputListener mil = new MouseInputAdapter(){
				public void mousePressed(MouseEvent ev){
					bx = ev.getX();
					by = ev.getY();
				}
				public void mouseDragged(MouseEvent ev){
					cx = ev.getX();
					cy = ev.getY();
					repaint();
				}
			};
			addMouseListener(mil);
			addMouseMotionListener(mil);
		}
		public void paintComponent(Graphics g){
			super.paintComponent(g);
			Graphics2D g2 = (Graphics2D)g;
			g2.setColor(Color.cyan);
			int bx = this.bx, by = this.by;
			int cx = this.cx, cy = this.cy;
			if(cx < bx){
				bx = this.cx;
				cx = this.bx;
			}
			if(cy < by){
				by = this.cy;
				cy = this.by;
			}
			Rectangle2D rec = new Rectangle2D.Double(bx, by, cx - bx, cy - by);
			g2.fill(rec);
		}
	}
	public ShapeDraw01(){
		super("ShapeDraw01 Test");
		getContentPane().add(new JPanel01());
		pack();
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setVisible(true);
	}
	public static void main(String[] args){
		new ShapeDraw01();
	}
}
