import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;

import java.util.*;

public class ShapeDraw02 extends JFrame {
	private class JPanel01 extends JPanel {
		private int bx, by;
		private int cx, cy;
		private LinkedList shapes = new LinkedList();
		Rectangle2D rec; 

		private JPanel01(){
			setPreferredSize(new Dimension(200, 200));
			setBackground(Color.white);
			MouseInputListener mil = new MouseInputAdapter(){
				public void mousePressed(MouseEvent ev){
					bx = ev.getX();
					by = ev.getY();
				}
				public void mouseReleased(MouseEvent ev){
					shapes.add(rec);
				}
				public void mouseDragged(MouseEvent ev){
					cx = ev.getX();
					cy = ev.getY();
					int bx = JPanel01.this.bx, by = JPanel01.this.by;
					int cx = JPanel01.this.cx, cy = JPanel01.this.cy;
					if(cx < bx){
						bx = JPanel01.this.cx;
						cx = JPanel01.this.bx;
					}
					if(cy < by){
						by = JPanel01.this.cy;
						cy = JPanel01.this.by;
					}
					rec = new Rectangle2D.Double(bx, by, cx - bx, cy - by);
					repaint();
				}
			};
			addMouseListener(mil);
			addMouseMotionListener(mil);
		}
		public void paintComponent(Graphics g){
			super.paintComponent(g);
			Graphics2D g2 = (Graphics2D)g;
			g2.setColor(Color.cyan);
			if(shapes != null){
				for(int i = 0; i < shapes.size(); i++){
					g2.fill((Rectangle2D)shapes.get(i));
				}
			}
			if(rec != null){
				g2.fill(rec);
			}
		}
	}
	public ShapeDraw02(){
		super("ShapeDraw02 Test");
		getContentPane().add(new JPanel01());
		pack();
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setVisible(true);
	}
	public static void main(String[] args){
		new ShapeDraw02();
	}
}
