import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;

public class Transparent01 extends JFrame {
	private class JPanel01 extends JPanel {
		private JPanel01(){
			setPreferredSize(new Dimension(300, 300));
			setBackground(Color.white);
		}
		public void paintComponent(Graphics g){
			super.paintComponent(g);
			Graphics2D g2 = (Graphics2D)g; 
			Rectangle2D rec = new Rectangle2D.Double(50, 50, 150, 150);
			g2.setColor(Color.yellow);
			g2.fill(rec);
			g2.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.3f));
			g2.setColor(Color.red);
			Ellipse2D ell = new Ellipse2D.Double(100, 100, 150, 150);
			g2.fill(ell);
		}
	}
	public Transparent01(){
		super("透明図形");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		getContentPane().add(new JPanel01());
		pack();
		setVisible(true);
	}
	public static void main(String[] args){
		new Transparent01();
	}
}
