import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;

public class Contains01 extends JFrame {
	private class JPanel01 extends JPanel {
		Ellipse2D ell = new Ellipse2D.Double(50, 50, 100, 100);

		private JPanel01(){
			setPreferredSize(new Dimension(200, 200));
			setBackground(Color.white);
			addMouseListener(new MouseAdapter(){
				public void mouseClicked(MouseEvent ev){
					if(ell.contains(ev.getX(), ev.getY())){
						System.out.println("IN");
					}else{
						System.out.println("OUT");
					}
				}
			});
		}
		public void paintComponent(Graphics g){
			super.paintComponent(g);
			Graphics2D g2 = (Graphics2D)g;
			g2.setColor(Color.magenta);
			g2.fill(ell);
		}
	}
	public Contains01(){
		super("Contains Test");
		getContentPane().add(new JPanel01());
		pack();
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setVisible(true);
	}
	public static void main(String[] args){
		new Contains01();
	}
}
