import java.io.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import javax.swing.*;
import javax.imageio.*;

public class ImageOut01 {
	public static void main(String[] args){
		try{
			String[] types = ImageIO.getWriterFormatNames();
			for(int i = 0; i < types.length; i++){
				System.out.print((i + 1) + "." + types[i] + " ");
			}
			System.out.println();
			System.out.print("出力ファイルの形式を選択して下さい : ");
    
			BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
			String type = types[Integer.parseInt(br.readLine()) - 1];
    
			BufferedImage bi = new BufferedImage(250, 250, BufferedImage.TYPE_INT_RGB);
			Graphics2D g2 = (Graphics2D)bi.getGraphics();
			g2.setBackground(Color.yellow);
			g2.clearRect(0, 0, 250, 250);
			Ellipse2D ell = new Ellipse2D.Double(50, 50, 100, 100);
			g2.setColor(Color.red);
			g2.fill(ell);
			Rectangle2D rec = new Rectangle2D.Double(100, 100, 100, 100);
			g2.setColor(Color.blue);
			g2.fill(rec);
			ImageIO.write(bi, type, new File("ImageOut." + type));
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
}
